---------------------------------------------------------------------------
-- SUPPORT CODE FOR PROOF OF CONCEPT STUFF
local function StatRingsTest_AlphaUpdate()
   local destAlpha = this.destAlpha;
   if (not destAlpha) then
      this:SetScript("OnUpdate", nil);
      return;
   end
   local nowAlpha = this:GetAlpha();
   if (nowAlpha < destAlpha) then
      nowAlpha = nowAlpha + (arg1/2);
      if (nowAlpha > destAlpha) then
	 nowAlpha = destAlpha;
      end
   elseif (nowAlpha > destAlpha) then
      nowAlpha = nowAlpha - (arg1/2);
      if (nowAlpha < destAlpha) then
	 nowAlpha = destAlpha;
      end
   end

   this:SetAlpha(nowAlpha);

   if (destAlpha == nowAlpha) then
      this.destAlpha = nil;
   end
end

function StatRingsTest_SetAlpha(this, destAlpha, instant)
   if (destAlpha < 0) then
      destAlpha = 0.0;
   elseif (destAlpha > 1) then
      destAlpha = 1.0;
   end

   if (instant) then
      this:SetAlpha(destAlpha);
      this.destAlpha = nil;
      return;
   end

   if (this:GetAlpha() == destAlpha) then
      return;
   end
   if (this.destAlpha == destAlpha) then
      return;
   end

   this.destAlpha = destAlpha;
   this:SetScript("OnUpdate", StatRingsTest_AlphaUpdate);
end

local installedWorldFrameCheck = nil;
local oldOnSizeChanged;

function StatRingsTest_CheckWorldFrameSize()
   if (not installedWorldFrameCheck) then
      oldOnSizeChanged = WorldFrame:GetScript("OnSizeChanged");
      local newCheck = function()
			  if (oldOnSizeChanged) then
			     oldOnSizeChanged();
			  end
			  StatRingsTest_CheckWorldFrameSize();
		       end
      WorldFrame:SetScript("OnSizeChanged", newCheck);
      installedWorldFrameCheck = true;
   end

   local worldHeight = WorldFrame:GetHeight();
   local manaSize = worldHeight / 2.35;
   local healthInner = manaSize + 5;
   local manaOffset = worldHeight * 0.12;

   local manaScale = manaSize / StatRingsMana:GetWidth();
   local healthScale = manaScale / 0.94;

   StatRingsMana:SetScale(manaScale);
   StatRingsHealth:SetScale(healthScale);

   StatRingsHealth:ClearAllPoints();
   StatRingsMana:SetPoint("CENTER", "WorldFrame", "CENTER", 0, -manaOffset);
   StatRingsHealth:ClearAllPoints();
   StatRingsHealth:SetPoint("CENTER", "StatRingsMana", "CENTER", 0, 0);
end
